/*
 * jQuery File Upload Plugin
 * https://github.com/blueimp/jQuery-File-Upload
 *
 * Copyright 2010, Sebastian Tschan
 * https://blueimp.net
 *
 * Licensed under the MIT license:
 * http://www.opensource.org/licenses/MIT
 */

/* jshint nomen:false */
/* global define, require, window, document, location, Blob, FormData */
(function(c){"function"===typeof define&&define.amd?define(["jquery","jquery.ui.widget"],c):"object"===typeof exports?c(require("jquery"),require("./vendor/jquery.ui.widget")):c(window.jQuery)})(function(c){function g(a){var b="dragover"===a;return function(d){d.dataTransfer=d.originalEvent&&d.originalEvent.dataTransfer;var e=d.dataTransfer;e&&-1!==c.inArray("Files",e.types)&&!1!==this._trigger(a,c.Event(a,{delegatedEvent:d}))&&(d.preventDefault(),b&&(e.dropEffect="copy"))}}c.support.fileInput=!(/(Android (1\.[0156]|2\.[01]))|(Windows Phone (OS 7|8\.0))|(XBLWP)|(ZuneWP)|(WPDesktop)|(w(eb)?OSBrowser)|(webOS)|(Kindle\/(1\.0|2\.[05]|3\.0))/.test(window.navigator.userAgent)||c('\x3cinput type\x3d"file"\x3e').prop("disabled"));c.support.xhrFileUpload=!(!window.ProgressEvent||!window.FileReader);c.support.xhrFormDataFileUpload=!!window.FormData;c.support.blobSlice=window.Blob&&(Blob.prototype.slice||Blob.prototype.webkitSlice||Blob.prototype.mozSlice);c.widget("blueimp.fileupload",{options:{dropZone:c(document),pasteZone:void 0,fileInput:void 0,replaceFileInput:!0,paramName:void 0,singleFileUploads:!0,limitMultiFileUploads:void 0,limitMultiFileUploadSize:void 0,limitMultiFileUploadSizeOverhead:512,sequentialUploads:!1,limitConcurrentUploads:void 0,forceIframeTransport:!1,redirect:void 0,redirectParamName:void 0,postMessage:void 0,multipart:!0,maxChunkSize:void 0,uploadedBytes:void 0,recalculateProgress:!0,progressInterval:100,bitrateInterval:500,autoUpload:!0,messages:{uploadedBytes:"Uploaded bytes exceed file size"},i18n:function(a,b){a=this.messages[a]||a.toString();b&&c.each(b,function(b,c){a=a.replace("{"+b+"}",c)});return a},formData:function(a){return a.serializeArray()},add:function(a,b){if(a.isDefaultPrevented())return!1;(b.autoUpload||!1!==b.autoUpload&&c(this).fileupload("option","autoUpload"))&&b.process().done(function(){b.submit()})},processData:!1,contentType:!1,cache:!1,timeout:0},_specialOptions:["fileInput","dropZone","pasteZone","multipart","forceIframeTransport"],_blobSlice:c.support.blobSlice&&function(){return(this.slice||this.webkitSlice||this.mozSlice).apply(this,arguments)},_BitrateTimer:function(){this.timestamp=Date.now?Date.now():(new Date).getTime();this.bitrate=this.loaded=0;this.getBitrate=function(a,b,c){var d=a-this.timestamp;if(!this.bitrate||!c||d>c)this.bitrate=1E3/d*(b-this.loaded)*8,this.loaded=b,this.timestamp=a;return this.bitrate}},_isXHRUpload:function(a){return!a.forceIframeTransport&&(!a.multipart&&c.support.xhrFileUpload||c.support.xhrFormDataFileUpload)},_getFormData:function(a){var b;return"function"===c.type(a.formData)?a.formData(a.form):c.isArray(a.formData)?a.formData:"object"===c.type(a.formData)?(b=[],c.each(a.formData,function(a,c){b.push({name:a,value:c})}),b):[]},_getTotal:function(a){var b=0;c.each(a,function(a,c){b+=c.size||1});return b},_initProgressObject:function(a){var b={loaded:0,total:0,bitrate:0};a._progress?c.extend(a._progress,b):a._progress=b},_initResponseObject:function(a){var b;if(a._response)for(b in a._response)a._response.hasOwnProperty(b)&&delete a._response[b];else a._response={}},_onProgress:function(a,b){if(a.lengthComputable){var d=Date.now?Date.now():(new Date).getTime(),e;b._time&&b.progressInterval&&d-b._time<b.progressInterval&&a.loaded!==a.total||(b._time=d,e=Math.floor(a.loaded/a.total*(b.chunkSize||b._progress.total))+(b.uploadedBytes||0),this._progress.loaded+=e-b._progress.loaded,this._progress.bitrate=this._bitrateTimer.getBitrate(d,this._progress.loaded,b.bitrateInterval),b._progress.loaded=b.loaded=e,b._progress.bitrate=b.bitrate=b._bitrateTimer.getBitrate(d,e,b.bitrateInterval),this._trigger("progress",c.Event("progress",{delegatedEvent:a}),b),this._trigger("progressall",c.Event("progressall",{delegatedEvent:a}),this._progress))}},_initProgressListener:function(a){var b=this,d=a.xhr?a.xhr():c.ajaxSettings.xhr();d.upload&&(c(d.upload).bind("progress",function(c){var d=c.originalEvent;c.lengthComputable=d.lengthComputable;c.loaded=d.loaded;c.total=d.total;b._onProgress(c,a)}),a.xhr=function(){return d})},_isInstanceOf:function(a,b){return Object.prototype.toString.call(b)==="[object "+a+"]"},_initXHRData:function(a){var b=this,d,e=a.files[0],f=a.multipart||!c.support.xhrFileUpload,h="array"===c.type(a.paramName)?a.paramName[0]:a.paramName;a.headers=c.extend({},a.headers);a.contentRange&&(a.headers["Content-Range"]=a.contentRange);f&&!a.blob&&this._isInstanceOf("File",e)||(a.headers["Content-Disposition"]='attachment; filename\x3d"'+encodeURI(e.name)+'"');f?c.support.xhrFormDataFileUpload&&(a.postMessage?(d=this._getFormData(a),a.blob?d.push({name:h,value:a.blob}):c.each(a.files,function(b,e){d.push({name:"array"===c.type(a.paramName)&&a.paramName[b]||h,value:e})})):(b._isInstanceOf("FormData",a.formData)?d=a.formData:(d=new FormData,c.each(this._getFormData(a),function(a,b){d.append(b.name,b.value)})),a.blob?d.append(h,a.blob,e.name):c.each(a.files,function(e,f){(b._isInstanceOf("File",f)||b._isInstanceOf("Blob",f))&&d.append("array"===c.type(a.paramName)&&a.paramName[e]||h,f,f.uploadName||f.name)})),a.data=d):(a.contentType=e.type||"application/octet-stream",a.data=a.blob||e);a.blob=null},_initIframeSettings:function(a){var b=c("\x3ca\x3e\x3c/a\x3e").prop("href",a.url).prop("host");a.dataType="iframe "+(a.dataType||"");a.formData=this._getFormData(a);a.redirect&&b&&b!==location.host&&a.formData.push({name:a.redirectParamName||"redirect",value:a.redirect})},_initDataSettings:function(a){this._isXHRUpload(a)?(this._chunkedUpload(a,!0)||(a.data||this._initXHRData(a),this._initProgressListener(a)),a.postMessage&&(a.dataType="postmessage "+(a.dataType||""))):this._initIframeSettings(a)},_getParamName:function(a){var b=c(a.fileInput),d=a.paramName;d?c.isArray(d)||(d=[d]):(d=[],b.each(function(){for(var a=c(this),b=a.prop("name")||"files[]",a=(a.prop("files")||[1]).length;a;)d.push(b),--a}),d.length||(d=[b.prop("name")||"files[]"]));return d},_initFormSettings:function(a){a.form&&a.form.length||(a.form=c(a.fileInput.prop("form")),a.form.length||(a.form=c(this.options.fileInput.prop("form"))));a.paramName=this._getParamName(a);a.url||(a.url=a.form.prop("action")||location.href);a.type=(a.type||"string"===c.type(a.form.prop("method"))&&a.form.prop("method")||"").toUpperCase();"POST"!==a.type&&"PUT"!==a.type&&"PATCH"!==a.type&&(a.type="POST");a.formAcceptCharset||(a.formAcceptCharset=a.form.attr("accept-charset"))},_getAJAXSettings:function(a){a=c.extend({},this.options,a);this._initFormSettings(a);this._initDataSettings(a);return a},_getDeferredState:function(a){return a.state?a.state():a.isResolved()?"resolved":a.isRejected()?"rejected":"pending"},_enhancePromise:function(a){a.success=a.done;a.error=a.fail;a.complete=a.always;return a},_getXHRPromise:function(a,b,d){var e=c.Deferred(),f=e.promise();b=b||this.options.context||f;!0===a?e.resolveWith(b,d):!1===a&&e.rejectWith(b,d);f.abort=e.promise;return this._enhancePromise(f)},_addConvenienceMethods:function(a,b){var d=this,e=function(a){return c.Deferred().resolveWith(d,a).promise()};b.process=function(a,h){if(a||h)b._processQueue=this._processQueue=(this._processQueue||e([this])).pipe(function(){return b.errorThrown?c.Deferred().rejectWith(d,[b]).promise():e(arguments)}).pipe(a,h);return this._processQueue||e([this])};b.submit=function(){"pending"!==this.state()&&(b.jqXHR=this.jqXHR=!1!==d._trigger("submit",c.Event("submit",{delegatedEvent:a}),this)&&d._onSend(a,this));return this.jqXHR||d._getXHRPromise()};b.abort=function(){if(this.jqXHR)return this.jqXHR.abort();this.errorThrown="abort";d._trigger("fail",null,this);return d._getXHRPromise(!1)};b.state=function(){if(this.jqXHR)return d._getDeferredState(this.jqXHR);if(this._processQueue)return d._getDeferredState(this._processQueue)};b.processing=function(){return!this.jqXHR&&this._processQueue&&"pending"===d._getDeferredState(this._processQueue)};b.progress=function(){return this._progress};b.response=function(){return this._response}},_getUploadedBytes:function(a){return(a=(a=(a=a.getResponseHeader("Range"))&&a.split("-"))&&1<a.length&&parseInt(a[1],10))&&a+1},_chunkedUpload:function(a,b){var d=a.files[0],e=d.size;if(e<a.maxChunkSize||0==a.maxChunkSize)return console.log("\u666e\u901a\u4e0a\u4f20"),!1;a.uploadedBytes=a.uploadedBytes||0;var f=this,d=a.files[0],e=d.size,h=a.uploadedBytes,l=a.maxChunkSize||e,k=this._blobSlice,m=c.Deferred(),n=m.promise(),p,g;if(!(this._isXHRUpload(a)&&k&&(h||l<e))||a.data)return!1;if(b)return!0;if(h>=e)return d.error=a.i18n("uploadedBytes"),this._getXHRPromise(!1,a.context,[null,"error",d.error]);g=function(){var b=c.extend({},a),n=b._progress.loaded;b.blob=k.call(d,h,h+l,d.type);b.chunkSize=b.blob.size;b.contentRange="bytes "+h+"-"+(h+b.chunkSize-1)+"/"+e;f._initXHRData(b);f._initProgressListener(b);p=(!1!==f._trigger("chunksend",null,b)&&c.ajax(b)||f._getXHRPromise(!1,b.context)).done(function(d,l,k){h=f._getUploadedBytes(k)||h+b.chunkSize;n+b.chunkSize-b._progress.loaded&&f._onProgress(c.Event("progress",{lengthComputable:!0,loaded:h-b.uploadedBytes,total:h-b.uploadedBytes}),b);a.uploadedBytes=b.uploadedBytes=h;b.result=d;b.textStatus=l;b.jqXHR=k;f._trigger("chunkdone",null,b);f._trigger("chunkalways",null,b);h<e?g():m.resolveWith(b.context,[d,l,k])}).fail(function(a,c,d){b.jqXHR=a;b.textStatus=c;b.errorThrown=d;f._trigger("chunkfail",null,b);f._trigger("chunkalways",null,b);m.rejectWith(b.context,[a,c,d])})};this._enhancePromise(n);n.abort=function(){return p.abort()};g();return n},_beforeSend:function(a,b){0===this._active&&(this._trigger("start"),this._bitrateTimer=new this._BitrateTimer,this._progress.loaded=this._progress.total=0,this._progress.bitrate=0);this._initResponseObject(b);this._initProgressObject(b);b._progress.loaded=b.loaded=b.uploadedBytes||0;b._progress.total=b.total=this._getTotal(b.files)||1;b._progress.bitrate=b.bitrate=0;this._active+=1;this._progress.loaded+=b.loaded;this._progress.total+=b.total},_onDone:function(a,b,d,e){var f=e._progress.total,h=e._response;e._progress.loaded<f&&this._onProgress(c.Event("progress",{lengthComputable:!0,loaded:f,total:f}),e);h.result=e.result=a;h.textStatus=e.textStatus=b;h.jqXHR=e.jqXHR=d;this._trigger("done",null,e)},_onFail:function(a,b,c,e){var d=e._response;e.recalculateProgress&&(this._progress.loaded-=e._progress.loaded,this._progress.total-=e._progress.total);d.jqXHR=e.jqXHR=a;d.textStatus=e.textStatus=b;d.errorThrown=e.errorThrown=c;this._trigger("fail",null,e)},_onAlways:function(a,b,c,e){this._trigger("always",null,e)},_onSend:function(a,b){b.submit||this._addConvenienceMethods(a,b);var d=this,e,f,h,l,k=d._getAJAXSettings(b),m=function(){d._sending+=1;k._bitrateTimer=new d._BitrateTimer;return e=e||((f||!1===d._trigger("send",c.Event("send",{delegatedEvent:a}),k))&&d._getXHRPromise(!1,k.context,f)||d._chunkedUpload(k)||c.ajax(k)).done(function(a,b,c){d._onDone(a,b,c,k)}).fail(function(a,b,c){d._onFail(a,b,c,k)}).always(function(a,b,c){d._onAlways(a,b,c,k);--d._sending;--d._active;if(k.limitConcurrentUploads&&k.limitConcurrentUploads>d._sending)for(a=d._slots.shift();a;){if("pending"===d._getDeferredState(a)){a.resolve();break}a=d._slots.shift()}0===d._active&&d._trigger("stop")})};this._beforeSend(a,k);return this.options.sequentialUploads||this.options.limitConcurrentUploads&&this.options.limitConcurrentUploads<=this._sending?(1<this.options.limitConcurrentUploads?(h=c.Deferred(),this._slots.push(h),l=h.pipe(m)):l=this._sequence=this._sequence.pipe(m,m),l.abort=function(){f=[void 0,"abort","abort"];return e?e.abort():(h&&h.rejectWith(k.context,f),m())},this._enhancePromise(l)):m()},_onAdd:function(a,b){var d=this,e=!0,f=c.extend({},this.options,b),h=b.files,l=h.length,k=f.limitMultiFileUploads,m=f.limitMultiFileUploadSize,n=f.limitMultiFileUploadSizeOverhead,g=0,t=this._getParamName(f),q,r,u=0;if(!l)return!1;m&&void 0===h[0].size&&(m=void 0);if((f.singleFileUploads||k||m)&&this._isXHRUpload(f))if(f.singleFileUploads||m||!k)if(!f.singleFileUploads&&m)for(r=[],q=[],f=0;f<l;f+=1){if(g+=h[f].size+n,f+1===l||g+h[f+1].size+n>m||k&&f+1-u>=k)r.push(h.slice(u,f+1)),g=t.slice(u,f+1),g.length||(g=t),q.push(g),u=f+1,g=0}else q=t;else for(r=[],q=[],f=0;f<l;f+=k)r.push(h.slice(f,f+k)),g=t.slice(f,f+k),g.length||(g=t),q.push(g);else r=[h],q=[t];b.originalFiles=h;c.each(r||h,function(f,h){var n=c.extend({},b);n.files=r?h:[h];n.paramName=q[f];d._initResponseObject(n);d._initProgressObject(n);d._addConvenienceMethods(a,n);return e=d._trigger("add",c.Event("add",{delegatedEvent:a}),n)});return e},_replaceFileInput:function(a){var b=a.fileInput,d=b.clone(!0),e=b.is(document.activeElement);a.fileInputClone=d;c("\x3cform\x3e\x3c/form\x3e").append(d)[0].reset();b.after(d).detach();e&&d.focus();c.cleanData(b.unbind("remove"));this.options.fileInput=this.options.fileInput.map(function(a,c){return c===b[0]?d[0]:c});b[0]===this.element[0]&&(this.element=d)},_handleFileTreeEntry:function(a,b){var d=this,e=c.Deferred(),f=function(b){b&&!b.entry&&(b.entry=a);e.resolve([b])},h=function(c){d._handleFileTreeEntries(c,b+a.name+"/").done(function(a){e.resolve(a)}).fail(f)},l=function(){k.readEntries(function(a){a.length?(g=g.concat(a),l()):h(g)},f)},k,g=[];b=b||"";a.isFile?a._file?(a._file.relativePath=b,e.resolve(a._file)):a.file(function(a){a.relativePath=b;e.resolve(a)},f):a.isDirectory?(k=a.createReader(),l()):e.resolve([]);return e.promise()},_handleFileTreeEntries:function(a,b){var d=this;return c.when.apply(c,c.map(a,function(a){return d._handleFileTreeEntry(a,b)})).pipe(function(){return Array.prototype.concat.apply([],arguments)})},_getDroppedFiles:function(a){a=a||{};var b=a.items;return b&&b.length&&(b[0].webkitGetAsEntry||b[0].getAsEntry)?this._handleFileTreeEntries(c.map(b,function(a){var b;if(a.webkitGetAsEntry){if(b=a.webkitGetAsEntry())b._file=a.getAsFile();return b}return a.getAsEntry()})):c.Deferred().resolve(c.makeArray(a.files)).promise()},_getSingleFileInputFiles:function(a){a=c(a);var b=a.prop("webkitEntries")||a.prop("entries");if(b&&b.length)return this._handleFileTreeEntries(b);b=c.makeArray(a.prop("files"));if(b.length)void 0===b[0].name&&b[0].fileName&&c.each(b,function(a,b){b.name=b.fileName;b.size=b.fileSize});else{a=a.prop("value");if(!a)return c.Deferred().resolve([]).promise();b=[{name:a.replace(/^.*\\/,"")}]}return c.Deferred().resolve(b).promise()},_getFileInputFiles:function(a){return a instanceof c&&1!==a.length?c.when.apply(c,c.map(a,this._getSingleFileInputFiles)).pipe(function(){return Array.prototype.concat.apply([],arguments)}):this._getSingleFileInputFiles(a)},_onChange:function(a){var b=this,d={fileInput:c(a.target),form:c(a.target.form)};this._getFileInputFiles(d.fileInput).always(function(e){d.files=e;b.options.replaceFileInput&&b._replaceFileInput(d);!1!==b._trigger("change",c.Event("change",{delegatedEvent:a}),d)&&b._onAdd(a,d)})},_onPaste:function(a){var b=a.originalEvent&&a.originalEvent.clipboardData&&a.originalEvent.clipboardData.items,d={files:[]};b&&b.length&&(c.each(b,function(a,b){var c=b.getAsFile&&b.getAsFile();c&&d.files.push(c)}),!1!==this._trigger("paste",c.Event("paste",{delegatedEvent:a}),d)&&this._onAdd(a,d))},_onDrop:function(a){a.dataTransfer=a.originalEvent&&a.originalEvent.dataTransfer;var b=this,d=a.dataTransfer,e={};d&&d.files&&d.files.length&&(a.preventDefault(),this._getDroppedFiles(d).always(function(d){e.files=d;!1!==b._trigger("drop",c.Event("drop",{delegatedEvent:a}),e)&&b._onAdd(a,e)}))},_onDragOver:g("dragover"),_onDragEnter:g("dragenter"),_onDragLeave:g("dragleave"),_initEventHandlers:function(){this._isXHRUpload(this.options)&&(this._on(this.options.dropZone,{dragover:this._onDragOver,drop:this._onDrop,dragenter:this._onDragEnter,dragleave:this._onDragLeave}),this._on(this.options.pasteZone,{paste:this._onPaste}));c.support.fileInput&&this._on(this.options.fileInput,{change:this._onChange})},_destroyEventHandlers:function(){this._off(this.options.dropZone,"dragenter dragleave dragover drop");this._off(this.options.pasteZone,"paste");this._off(this.options.fileInput,"change")},_setOption:function(a,b){var d=-1!==c.inArray(a,this._specialOptions);d&&this._destroyEventHandlers();this._super(a,b);d&&(this._initSpecialOptions(),this._initEventHandlers())},_initSpecialOptions:function(){var a=this.options;void 0===a.fileInput?a.fileInput=this.element.is('input[type\x3d"file"]')?this.element:this.element.find('input[type\x3d"file"]'):a.fileInput instanceof c||(a.fileInput=c(a.fileInput));a.dropZone instanceof c||(a.dropZone=c(a.dropZone));a.pasteZone instanceof c||(a.pasteZone=c(a.pasteZone))},_getRegExp:function(a){a=a.split("/");var b=a.pop();a.shift();return new RegExp(a.join("/"),b)},_isRegExpOption:function(a,b){return"url"!==a&&"string"===c.type(b)&&/^\/.*\/[igm]{0,3}$/.test(b)},_initDataAttributes:function(){var a=this,b=this.options,d=this.element.data();c.each(this.element[0].attributes,function(c,f){var e=f.name.toLowerCase(),l;/^data-/.test(e)&&(e=e.slice(5).replace(/-[a-z]/g,function(a){return a.charAt(1).toUpperCase()}),l=d[e],a._isRegExpOption(e,l)&&(l=a._getRegExp(l)),b[e]=l)})},_create:function(){this._initDataAttributes();this._initSpecialOptions();this._slots=[];this._sequence=this._getXHRPromise(!0);this._sending=this._active=0;this._initProgressObject(this);this._initEventHandlers()},active:function(){return this._active},progress:function(){return this._progress},add:function(a){var b=this;a&&!this.options.disabled&&(a.fileInput&&!a.files?this._getFileInputFiles(a.fileInput).always(function(c){a.files=c;b._onAdd(null,a)}):(a.files=c.makeArray(a.files),this._onAdd(null,a)))},send:function(a){if(a&&!this.options.disabled){if(a.fileInput&&!a.files){var b=this,d=c.Deferred(),e=d.promise(),f,h;e.abort=function(){h=!0;if(f)return f.abort();d.reject(null,"abort","abort");return e};this._getFileInputFiles(a.fileInput).always(function(c){h||(c.length?(a.files=c,f=b._onSend(null,a),f.then(function(a,b,c){d.resolve(a,b,c)},function(a,b,c){d.reject(a,b,c)})):d.reject())});return this._enhancePromise(e)}a.files=c.makeArray(a.files);if(a.files.length)return this._onSend(null,a)}return this._getXHRPromise(!1,a&&a.context)}})});function fileupload_file_init(c){$("#fileupload_"+c.name).fileupload({disableImageResize:!1,autoUpload:!0,maxFileSize:c.size,url:c.url,dataType:"json",acceptFileTypes:c.ext,maxChunkSize:c.chunk,progressall:function(g,a){var b=parseInt(a.loaded/a.total*100,10);$("#fileupload_"+c.name+" .fileupload-progress").show();$("#fileupload_"+c.name+" .fileupload-progress").removeClass("fade");$("#fileupload_"+c.name+" .progress-bar-success").attr("style","width: "+b+"%")},add:function(g,a){$("#fileupload_"+c.name+" .fileupload-progress").hide();a.submit()},done:function(g,a){dr_tips(a.result.code,a.result.msg);$("#fileupload_"+c.name+" .fileupload-progress").addClass("fade");$("#fileupload_"+c.name+" .fileupload-progress").hide();if(0==a.result.code||void 0==a.result.id||"undefined"==a.result.id)return!1;var b=c.tpl,b=b.replace(/\{preview\}/g,a.result.info.preview),b=b.replace(/\{id\}/g,a.result.id),b=b.replace(/\{filepath\}/g,a.result.info.file),b=b.replace(/\{title\}/g,a.result.info.name),b=b.replace(/\{upload\}/g,'\x3cinput type\x3d"file" name\x3d"file_data"\x3e\x3c/button\x3e');$("#fileupload_"+c.name+"_files").html(b);$("#fileupload_"+c.name).find(".fileinput-delete").show()},fail:function(g,a){dr_tips(0,dr_lang("\u4e0a\u4f20\u8bf7\u6c42\u9519\u8bef\uff1a")+a.errorThrown);$("#fileupload_"+c.name+" .fileupload-progress").addClass("fade");$("#fileupload_"+c.name+" .fileupload-progress").hide()}});$("#fileupload_"+c.name+" .fileinput-unused").click(function(){var g=$("#fileupload_"+c.name+" .files_row").length,a=c.unused_url+"\x26ct\x3d"+g+"\x26rand\x3d"+Math.random();layer.open({type:2,title:'\x3ci class\x3d"fa fa-folder-open"\x3e\x3c/i\x3e',fix:!0,scrollbar:!1,shadeClose:!0,shade:0,area:c.area,btn:[lang.ok],yes:function(b,d){var e=layer.getChildFrame("body",b),f=layer.load(2,{time:1E7});$.ajax({type:"POST",dataType:"json",url:a,data:$(e).find("#myform").serialize(),success:function(a){layer.close(f);if(1==a.code){layer.close(b);var d=c.tpl,e="",h=a.data.result[0],d=d.replace(/\{preview\}/g,h.preview),d=d.replace(/\{id\}/g,h.id),d=d.replace(/\{filepath\}/g,h.file),d=d.replace(/\{title\}/g,h.name),d=d.replace(/\{upload\}/g,h.upload),e=e+d;$("#fileupload_"+c.name+"_files").html(e);$("#fileupload_"+c.name).find(".fileinput-delete").show();dr_tips(1,a.msg)}else dr_tips(0,a.msg);return!1}});return!1},success:function(a,c){var b=layer.getChildFrame("body",c),b=$(b).html();if(0<b.indexOf('"code":0')&&150>jso2n.length){var d=JSON.parse(b);layer.close(c);dr_tips(0,d.msg)}0<b.indexOf('"code":1')&&150>b.length&&(d=JSON.parse(b),layer.close(c),dr_tips(1,d.msg))},content:a+"\x26is_iframe\x3d1"})});$("#fileupload_"+c.name+" .fileinput-url").click(function(){layer.open({type:2,title:'\x3ci class\x3d"fa fa-edit"\x3e\x3c/i\x3e ',fix:!0,scrollbar:!1,shadeClose:!0,shade:0,area:c.url_area,btn:[lang.ok],yes:function(g,a){var b=layer.getChildFrame("body",g),d=layer.load(2,{time:1E7});$.ajax({type:"POST",dataType:"json",url:c.input_url,data:$(b).find("#myform").serialize(),success:function(a){layer.close(d);if(1==a.code){layer.close(g);var b=c.tpl,b=b.replace(/\{preview\}/g,a.data.preview),b=b.replace(/\{id\}/g,a.data.id),b=b.replace(/\{filepath\}/g,a.data.file),b=b.replace(/\{title\}/g,a.data.name),b=b.replace(/\{upload\}/g,a.data.upload);$("#fileupload_"+c.name+"_files").html(b);$("#fileupload_"+c.name).find(".fileinput-delete").show();dr_tips(1,a.msg)}else dr_tips(0,a.msg);return!1}});return!1},success:function(c,a){var b=layer.getChildFrame("body",a),b=$(b).html();if(0<b.indexOf('"code":0')&&150>b.length){var d=JSON.parse(b);layer.close(a);dr_tips(0,d.msg)}0<b.indexOf('"code":1')&&150>b.length&&(d=JSON.parse(b),layer.close(a),dr_tips(1,d.msg))},content:c.input_url+"\x26is_iframe\x3d1"})})}function fileupload_file_remove(c){$("#fileupload_"+c+"_files").html("");$("#fileupload_"+c).find(".fileinput-delete").hide()}function fileupload_files_init(c){$("#fileupload_"+c.name+"_files").sortable();dr_slimScroll_init(".scroller_"+c.name+"_files",300);$("#fileupload_"+c.name).fileupload({disableImageResize:!1,autoUpload:!0,maxFileSize:c.size,acceptFileTypes:c.ext,maxChunkSize:c.chunk,url:c.url,dataType:"json",progressall:function(g,a){var b=parseInt(a.loaded/a.total*100,10);$("#fileupload_"+c.name+" .fileupload-progress").show();$("#fileupload_"+c.name+" .fileupload-progress").removeClass("fade");$("#fileupload_"+c.name+" .progress-bar-success").attr("style","width: "+b+"%")},add:function(g,a){var b=a.originalFiles.length;if($("#fileupload_"+c.name+"_files .files_row").length+b>c.count)return dr_tips(0,c.error),!1;a.submit()},done:function(g,a){dr_tips(a.result.code,a.result.msg);$("#fileupload_"+c.name+" .fileupload-progress").hide();$("#fileupload_"+c.name+" .fileupload-progress").addClass("fade");if(0==a.result.code||void 0==a.result.id||"undefined"==a.result.id)return!1;var b=c.tpl,b=b.replace(/\{preview\}/g,a.result.info.preview),b=b.replace(/\{id\}/g,a.result.id),b=b.replace(/\{disabled\}/g,"disabled"),b=b.replace(/\{filepath\}/g,a.result.info.file),b=b.replace(/\{title\}/g,a.result.info.name),b=b.replace(/\{description\}/g,""),b=b.replace(/\{upload\}/g,'\x3cinput type\x3d"file" name\x3d"file_data"\x3e\x3c/button\x3e');$("#fileupload_"+c.name+"_files").append(b);dr_slimScroll_init(".scroller_"+c.name+"_files",300)},fail:function(g,a){dr_tips(0,dr_lang("\u4e0a\u4f20\u8bf7\u6c42\u9519\u8bef\uff1a")+a.errorThrown);$("#fileupload_"+c.name+" .fileupload-progress").addClass("fade");$("#fileupload_"+c.name+" .fileupload-progress").hide()}});$("#fileupload_"+c.name+"_files .file_edit").fileupload({disableImageResize:!1,autoUpload:!0,maxFileSize:c.size,acceptFileTypes:c.ext,url:c.url,maxChunkSize:c.chunk,dataType:"json",progressall:function(g,a){var b=parseInt(a.loaded/a.total*100,10);$("#fileupload_"+c.name+" .fileupload-progress").show();$("#fileupload_"+c.name+" .fileupload-progress").removeClass("fade");$("#fileupload_"+c.name+" .progress-bar-success").attr("style","width: "+b+"%")},done:function(g,a){$("#fileupload_"+c.name+" .fileupload-progress").addClass("fade");$("#fileupload_"+c.name+" .fileupload-progress").hide();dr_tips(a.result.code,a.result.msg);if(0==a.result.code||void 0==a.result.id||"undefined"==a.result.id)return!1;$(this).parents(".files_row").find(".files_row_id").val(a.result.id);$(this).parents(".files_row").find(".files_row_name").val(a.result.info.file);$(this).parents(".files_row").find(".files_row_preview").html(a.result.info.preview)},fail:function(g,a){dr_tips(0,dr_lang("\u4e0a\u4f20\u8bf7\u6c42\u9519\u8bef\uff1a")+a.errorThrown);$("#fileupload_"+c.name+" .fileupload-progress").addClass("fade");$("#fileupload_"+c.name+" .fileupload-progress").hide()}});$("#fileupload_"+c.name+" .fileinput-unused").click(function(){var g=$("#fileupload_"+c.name+"_files .files_row").length,a=c.unused_url+"\x26ct\x3d"+g+"\x26rand\x3d"+Math.random();layer.open({type:2,title:'\x3ci class\x3d"fa fa-folder-open"\x3e\x3c/i\x3e',fix:!0,scrollbar:!1,shadeClose:!0,shade:0,area:c.area,btn:[lang.ok],yes:function(b,d){var e=layer.getChildFrame("body",b),f=layer.load(2,{time:1E7});$.ajax({type:"POST",dataType:"json",url:a,data:$(e).find("#myform").serialize(),success:function(a){layer.close(f);if(1==a.code){layer.close(b);var d=c.count;if($("#fileupload_"+c.name+"_files .files_row").length+a.data.count>d)return dr_tips(0,c.error),!1;var d="",e=c.tpl,h;for(h in a.data.result){var g=e,p=a.data.result[h];void 0!=p.id&&"undefined"!=p.id&&(g=g.replace(/\{preview\}/g,p.preview),g=g.replace(/\{id\}/g,p.id),g=g.replace(/\{disabled\}/g,p.disabled),g=g.replace(/\{filepath\}/g,p.file),g=g.replace(/\{title\}/g,p.name),g=g.replace(/\{description\}/g,""),g=g.replace(/\{upload\}/g,p.upload),d+=g)}$("#fileupload_"+c.name+"_files").append(d);dr_slimScroll_init(".scroller_"+c.name+"_files",300);dr_tips(1,a.msg)}else dr_tips(0,a.msg);return!1}});return!1},success:function(a,c){var b=layer.getChildFrame("body",c),b=$(b).html();if(0<b.indexOf('"code":0')&&150>jso2n.length){var d=JSON.parse(b);layer.close(c);dr_tips(0,d.msg)}0<b.indexOf('"code":1')&&150>b.length&&(d=JSON.parse(b),layer.close(c),dr_tips(1,d.msg))},content:a+"\x26is_iframe\x3d1"})});$("#fileupload_"+c.name+" .fileinput-url").click(function(){layer.open({type:2,title:'\x3ci class\x3d"fa fa-edit"\x3e\x3c/i\x3e ',fix:!0,scrollbar:!1,shadeClose:!0,shade:0,area:c.url_area,btn:[lang.ok],yes:function(g,a){var b=layer.getChildFrame("body",g),d=layer.load(2,{time:1E7});$.ajax({type:"POST",dataType:"json",url:c.input_url,data:$(b).find("#myform").serialize(),success:function(a){layer.close(d);if(1==a.code){layer.close(g);var b=c.tpl,b=b.replace(/\{preview\}/g,a.data.preview),b=b.replace(/\{id\}/g,a.data.id),b=b.replace(/\{disabled\}/g,a.data.disabled),b=b.replace(/\{filepath\}/g,a.data.file),b=b.replace(/\{title\}/g,a.data.name),b=b.replace(/\{description\}/g,""),b=b.replace(/\{upload\}/g,a.data.upload);$("#fileupload_"+c.name+"_files").append(b);dr_tips(1,a.msg)}else dr_tips(0,a.msg);return!1}});return!1},success:function(c,a){var b=layer.getChildFrame("body",a),b=$(b).html();if(0<b.indexOf('"code":0')&&150>b.length){var d=JSON.parse(b);layer.close(a);dr_tips(0,d.msg)}0<b.indexOf('"code":1')&&150>b.length&&(d=JSON.parse(b),layer.close(a),dr_tips(1,d.msg))},content:c.input_url+"\x26is_iframe\x3d1"})})}function fileupload_file_edit(c,g){var a=eval("files_json_"+c);if(-1==$(g).html().indexOf("file_data")){var b=$(g).parents(".files_row"),d=encodeURIComponent(b.find(".files_row_name").val());c=encodeURIComponent(b.find(".files_row_title").val());var e=b.find(".files_row_name").attr("readonly");"readonly"!=e&&1!=e&&layer.open({type:2,title:'\x3ci class\x3d"fa fa-edit"\x3e\x3c/i\x3e ',fix:!0,scrollbar:!1,shadeClose:!0,shade:0,area:a.url_area,btn:[lang.ok],yes:function(c,d){var e=layer.getChildFrame("body",c),f=layer.load(2,{time:1E7});$.ajax({type:"POST",dataType:"json",url:a.input_url,data:$(e).find("#myform").serialize(),success:function(d){layer.close(f);if(1==d.code){layer.close(c);var e=a.tpl,e=e.replace(/\{preview\}/g,d.data.preview),e=e.replace(/\{id\}/g,d.data.id),e=e.replace(/\{disabled\}/g,d.data.disabled),e=e.replace(/\{filepath\}/g,d.data.file),e=e.replace(/\{title\}/g,d.data.name),e=e.replace(/\{description\}/g,""),e=e.replace(/\{upload\}/g,d.data.upload);b.remove();$("#fileupload_"+a.name+"_files").append(e);dr_tips(1,d.msg)}else dr_tips(0,d.msg);return!1}});return!1},success:function(a,b){var c=layer.getChildFrame("body",b),c=$(c).html();if(0<c.indexOf('"code":0')&&150>c.length){var d=JSON.parse(c);layer.close(b);dr_tips(0,d.msg)}0<c.indexOf('"code":1')&&150>c.length&&(d=JSON.parse(c),layer.close(b),dr_tips(1,d.msg))},content:a.input_url+"\x26is_iframe\x3d1\x26file\x3d"+d+"\x26name\x3d"+c})}};